void CChartInfo::sort_aspects(int n, int flags, int *ord, int n_ord)
{
	int i, j, tmp, n1a, n1b, n2a, n2b;
	bool do_swap;

	if((n < 0) && ((flags & INFO_ASPECTS_BYORB) ||
	   (flags & INFO_ASPECTS_BYPL1) || (flags & INFO_ASPECTS_BYPL2)))
	{
		for(i = 0; i < n_ord; i++)
		{
			ord[i] = i;
			for(j = i; j > 0; j--)
			{
				get_swapped_aspects(ord[j],     n, &n1a, &n2a);
				get_swapped_aspects(ord[j - 1], n, &n1b, &n2b);
				if(IS_HOUSE(n1a)) n1a = n1a - FIRST_HOUSE + FIRST_PLANET + NTOTOBJECTS;
				if(IS_HOUSE(n2a)) n2a = n2a - FIRST_HOUSE + FIRST_PLANET + NTOTOBJECTS;
				if(IS_HOUSE(n1b)) n1b = n1b - FIRST_HOUSE + FIRST_PLANET + NTOTOBJECTS;
				if(IS_HOUSE(n2b)) n2b = n2b - FIRST_HOUSE + FIRST_PLANET + NTOTOBJECTS;
				if(flags & INFO_ASPECTS_BYORB)
					do_swap = aspect_cache[ord[j]].orb < aspect_cache[ord[j - 1]].orb;
				else if(!(viewmode & TRANSITS_CHART) && (flags & INFO_ASPECTS_BYPL1))
					do_swap = (n1a < n1b) || ((n1a == n1b) && (n2a < n2b));
				else if(!(viewmode & TRANSITS_CHART) && (flags & INFO_ASPECTS_BYPL2))
					do_swap = (n2a < n2b) || ((n2a == n2b) && (n1a < n1b));
				else if((viewmode & TRANSITS_CHART) && (flags & INFO_ASPECTS_BYPL1))
					do_swap = (n2a < n2b) || ((n2a == n2b) && (n1a < n1b));
				else if((viewmode & TRANSITS_CHART) && (flags & INFO_ASPECTS_BYPL2))
					do_swap = (n1a < n1b) || ((n1a == n1b) && (n2a < n2b));
				else
					do_swap = FALSE;
				if(do_swap)
				{
					tmp = ord[j - 1];
					ord[j - 1] = ord[j];
					ord[j] = tmp;
				}
			}
		}
	}
	else
	{
		for(i = 0; i < n_ord; i++)
			ord[i] = i;
	}
}
